unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls,
  Types, LCLType, LCLIntf;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    PaintBox1: TPaintBox;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    FProgress: Integer;

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  FProgress := 0;
  Timer1.Enabled := true;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
var
  R: TRect;
  sz: TSize;
  s: String;
begin
  R := Rect(0, 0, Paintbox1.Width, Paintbox1.Height);
  Paintbox1.Canvas.Brush.Style := bsSolid;
  Paintbox1.Canvas.Brush.Color := clWhite;
  Paintbox1.Canvas.Rectangle(R);
  if FProgress > 0 then
  begin
    InflateRect(R, -1, -1);
    R.Right := R.Left + MulDiv(FProgress, R.Right - R.Left, 100);
    Paintbox1.Canvas.Brush.Color := clSkyBlue;
    Paintbox1.Canvas.FillRect(R);
    Paintbox1.Canvas.Font.Assign(Paintbox1.Font);
    Paintbox1.Canvas.Brush.Style := bsClear;
    s := Format('%d %%', [FProgress]);
    sz := Paintbox1.Canvas.TextExtent(s);
    Paintbox1.Canvas.TextOut((Paintbox1.Width - sz.CX) div 2, (Paintbox1.Height - sz.CY) div 2, s);
  end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  FProgress := FProgress + 1;
  Paintbox1.Invalidate;
  if FProgress = 100 then
    Timer1.Enabled := false;
end;

end.

